;; -*-emacs-lisp-*-

;; Figure out package dir:
(let ((package-dir (concat "/usr/share/"
			   (symbol-name debian-emacs-flavor)
			   "/site-lisp/vala-mode-el")))
  ;; If package-dir does not exist, this package must have been
  ;; removed but not purged, and we should skip the setup.
  (when (file-directory-p package-dir)

    ;; add it to the load-path:
    (cond ((fboundp 'debian-pkg-add-load-path-item)
	   (debian-pkg-add-load-path-item package-dir))
	  ((fboundp 'add-to-list)
	   (add-to-list load-path package-dir))
	  (t
	   (setq load-path (cons package-dir load-path))))

    ;; Installation snippets per https://wiki.gnome.org/Projects/Vala/Emacs
    ;; Direct support for Vala source code:
    (autoload 'vala-mode "vala-mode" "Major mode for editing Vala code." t)
    (add-to-list 'auto-mode-alist '("\\.vala$" . vala-mode))
    (add-to-list 'auto-mode-alist '("\\.vapi$" . vala-mode))
    (add-to-list 'file-coding-system-alist '("\\.vala$" . utf-8))
    (add-to-list 'file-coding-system-alist '("\\.vapi$" . utf-8))

    ;; Use C# semantics when ECB and CEDET are both installed:
    (when (and (file-exists-p "/usr/share/emacs/site-lisp/ecb/ecb.el")
	       (fboundp 'wisent-csharp-default-setup))
      (add-hook 'vala-mode-hook #'wisent-csharp-default-setup))))
